Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class InputStreamReader

    java.lang.Object
      |
      +--java.io.Reader
            |
            +--java.io.InputStreamReader

Direct Known Subclasses:
  FileReader

public class InputStreamReader
extends Reader

An InputStreamReader is a bridge from byte streams to character streams: It reads bytes and decodes them into characters using a specified ``charset``. The charset that it uses may be specified by name or may be given explicitly, or the platform's default charset may be accepted.

Each invocation of one of an InputStreamReader's read() methods may cause one or more bytes to be read from the underlying byte-input stream. To enable the efficient conversion of bytes to characters, more bytes may be read ahead from the underlying stream than are necessary to satisfy the current read operation.

For top efficiency, consider wrapping an InputStreamReader within a BufferedReader. For example:

     BufferedReader in
       = new BufferedReader(new InputStreamReader(System.in));

Since:
  JDK1.1
See Also:
  `BufferedReader`, `InputStream`, `Charset`

Field Summary

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`InputStreamReader(InputStream in)` Create an InputStreamReader that uses the default charset.
`InputStreamReader(InputStream in, Charset cs)` Create an InputStreamReader that uses the given charset.
`InputStreamReader(InputStream in, CharsetDecoder dec)` Create an InputStreamReader that uses the given charset decoder.
`InputStreamReader(InputStream in, String charsetName)` Create an InputStreamReader that uses the named charset.

Method Summary
`void` | `close()` Close the stream.
`String` | `getEncoding()` Return the name of the character encoding being used by this stream.
`int` | `read()` Read a single character.
`int` | `read(char[] cbuf, int offset, int length)` Read characters into a portion of an array.
`boolean` | `ready()` Tell whether this stream is ready to be read.

Methods inherited from class java.io.Reader
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InputStreamReader

    public InputStreamReader(InputStream in)

  Create an InputStreamReader that uses the default charset.

Parameters:
  `in` - An InputStream

### InputStreamReader

    public InputStreamReader(InputStream in,
                             String charsetName)
                      throws UnsupportedEncodingException

  Create an InputStreamReader that uses the named charset.

Parameters:
  `in` - An InputStream
  `charsetName` - The name of a supported ``charset``
Throws:
  `UnsupportedEncodingException` - If the named charset is not supported

### InputStreamReader

    public InputStreamReader(InputStream in,
                             Charset cs)

  Create an InputStreamReader that uses the given charset.

Parameters:
  `in` - An InputStream
  `cs` - A charset
Since:
  1.4

### InputStreamReader

    public InputStreamReader(InputStream in,
                             CharsetDecoder dec)

  Create an InputStreamReader that uses the given charset decoder.

Parameters:
  `in` - An InputStream
  `dec` - A charset decoder
Since:
  1.4

Method Detail

### getEncoding

    public String getEncoding()

  Return the name of the character encoding being used by this stream.

  If the encoding has an historical name then that name is returned; otherwise the encoding's canonical name is returned.

  If this instance was created with the `InputStreamReader(InputStream, String)` constructor then the returned name, being unique for the encoding, may differ from the name passed to the constructor. This method may return `null` if the stream has been closed.

  Returns:
    The historical name of this encoding, or possibly `null` if the stream has been closed
  See Also:
    `Charset`

### read

    public int read()
             throws IOException

  Read a single character.

  Overrides:
    `read` in class `Reader`
  Returns:
    The character read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### read

    public int read(char[] cbuf,
                    int offset,
                    int length)
             throws IOException

  Read characters into a portion of an array.

  Specified by:
    `read` in class `Reader`
  Parameters:
    `cbuf` - Destination buffer
    `offset` - Offset at which to start storing characters
    `length` - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### ready

    public boolean ready()
                  throws IOException

  Tell whether this stream is ready to be read. An InputStreamReader is ready if its input buffer is not empty, or if bytes are available to be read from the underlying byte stream.

  Overrides:
    `ready` in class `Reader`
  Returns:
    True if the next read() is guaranteed not to block for input, false otherwise. Note that returning false does not guarantee that the next read will block.
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.

  Specified by:
    `close` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.